﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class AlphaChange : MonoBehaviour {

    public float fadeTime = 0f;	// フェードにどれだけ時間をかけるか
	float m_Timer = 0.0f;		// 内部タイマー 

    private float m_FadeOutTimer;
    private SpriteRenderer spRenderer;

    // Use this for initialization
    void Start()
    {
        // 初期化
        m_FadeOutTimer = fadeTime;
        spRenderer = GetComponent<SpriteRenderer>();
    }

    // Update is called once per frame
    void Update()
    {
        m_Timer += Time.deltaTime;

		if(m_Timer < fadeTime){
			// フェードイン
			float alpha = m_Timer / fadeTime;					// アルファ値 
			spRenderer.color = new Color(1, 1, 1, alpha);
		}
		else{
			// フェードアウト 
			float alpha = (2*fadeTime - m_Timer) / fadeTime;	// アルファ値 
			spRenderer.color = new Color(1, 1, 1, alpha);
		}

		if(m_Timer > fadeTime * 2){
			m_Timer = 0;
		}

		/*
		if (alpha >= 0.0f) {
            m_Timer = Time.deltaTime;
            m_FadeOutTimer -= m_Timer;
            // フェードアウト
            alpha = m_FadeOutTimer / fadeTime;
            var color = spRenderer.color;
            color.a = alpha;
            spRenderer.color = color;

        }
        if (alpha <= 0.0f)
        {
            m_Timer = Time.deltaTime;
            m_FadeOutTimer += m_Timer;
            //フェードイン
            alpha = m_FadeOutTimer / fadeTime;
            var color = spRenderer.color;
            color.a = alpha;
            spRenderer.color = color;

        }*/
        //Debug.Log(m_FadeOutTimer);
    }
}
