﻿// SoundPlayer.cs
//
// @idex Unity5.5.0f1 / MonoDevelop5.9.6
// @auth GGJFKS17C.FCEI.No-Va
// @date 2017/01/21 
//------------------------------------------------------------------------------------------------------------------------
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//----------------------------------------------------------------------------------------------------
// サウンド管理 
//----------------------------------------------------------------------------------------------------
public class SoundPlayer : MonoBehaviour
{
	//--------------------------------------------------------------------------------
	// サウンドリスト  
	//--------------------------------------------------------------------------------
	public enum SE{
		JUMP,	// ジャンプ
		WATER,	// 着地 
		SCORE	// スコア加算 
	}

	public enum BGM{
		MAIN,	// メイン曲 
		TITLE,	// タイトル曲 
		RESULT,	// リザルトジングル		 
	}

	//--------------------------------------------------------------------------------
	// メバ変数 
	//--------------------------------------------------------------------------------
	static SoundPlayer instance;	// インスタンス 

	[SerializeField]AudioSource se_jump    = null;
	[SerializeField]AudioSource se_water   = null;
	[SerializeField]AudioSource se_score   = null;
	[SerializeField]AudioSource bgm_main   = null;
	[SerializeField]AudioSource bgm_title  = null;
	[SerializeField]AudioSource bgm_result = null;

	//--------------------------------------------------------------------------------
	// コンストラクタ 
	//--------------------------------------------------------------------------------
	void Awake ()
	{
		// シングルトン生成 (Fast-Priority型) 
		if(instance == null){
			instance = this;
			DontDestroyOnLoad(this.gameObject);
		}
		else{
			GameObject.Destroy(this.gameObject);
		}
	}

	//--------------------------------------------------------------------------------
	// SE再生 
	//--------------------------------------------------------------------------------
	public static void PlaySE(SE se)
	{
		switch(se){
			case SE.JUMP:	{ instance.se_jump.Play();  break; }
			case SE.WATER:	{ instance.se_water.Play(); break; }
			case SE.SCORE:	{ instance.se_score.Play(); break; }
		}
	}

	//--------------------------------------------------------------------------------
	// BGM再生 
	//--------------------------------------------------------------------------------
	public static void PlayBGM(BGM bgm)
	{
		StopBGM();
		switch(bgm){
			case BGM.MAIN: 	 { instance.bgm_main.Play();   break; }
			case BGM.TITLE:  { instance.bgm_title.Play();  break; }
			case BGM.RESULT: { instance.bgm_result.Play(); break; }
		}
	}

	//--------------------------------------------------------------------------------
	// BGM停止
	//--------------------------------------------------------------------------------
	public static void StopBGM ()
	{
		for(int i=0; i<Enums<BGM>.Length; i++){
			StopBGM((BGM)i);
		}
	}
	public static void StopBGM (BGM bgm)
	{
		switch(bgm){
			case BGM.MAIN:   { instance.bgm_main.Stop();   break; }
			case BGM.TITLE:  { instance.bgm_title.Stop();  break; }
			case BGM.RESULT: { instance.bgm_result.Stop(); break; }
		}
	}

	//--------------------------------------------------------------------------------
	// debug 
	//--------------------------------------------------------------------------------
	void Update ()
	{
		if(DebugSwitch.isDebugEnable == false){ return; }

		if(Input.GetKeyDown(KeyCode.Alpha1)){ PlaySE(SE.JUMP); }
		if(Input.GetKeyDown(KeyCode.Alpha2)){ PlaySE(SE.WATER); }
		if(Input.GetKeyDown(KeyCode.Alpha3)){ PlaySE(SE.SCORE); }
		if(Input.GetKeyDown(KeyCode.Alpha4)){ PlayBGM(BGM.MAIN); }
		if(Input.GetKeyDown(KeyCode.Alpha5)){ PlayBGM(BGM.TITLE); }
	}
}
