﻿// SpeedFx.cs
//
// @idex Unity5.5.0f1 / MonoDevelop5.9.6
// @auth GGJFKS17C.FCEI.No-Va
// @date 2017/01/21 
//------------------------------------------------------------------------------------------------------------------------
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

//----------------------------------------------------------------------------------------------------
// スピード演出管理 
//------------------------------------------------------------------------------------------
public class SpeedFx : MonoBehaviour
{
	//--------------------------------------------------------------------------------
	// メンバ変数  
	//--------------------------------------------------------------------------------
	static SpeedFx instance; 
	[SerializeField]SpeedFxObj baseObject = null; //@@ Instantiateの元 

	const int NUM = 3;		// 同時生成数 

	//--------------------------------------------------------------------------------
	// コンストラクタ 
	//--------------------------------------------------------------------------------
	void Awake ()
	{
		// シングルトン生成 (Fast-Priority型) 
		if(instance == null){
			instance = this;
			DontDestroyOnLoad(this.gameObject);
		}
		else{
			GameObject.Destroy(this.gameObject);
		}
	}

	//--------------------------------------------------------------------------------
	// 生成　
	//--------------------------------------------------------------------------------
	public static void Spawn ()
	{
		instance.SpawnNaked();
	}
	void SpawnNaked ()
	{
		GameObject obj = Instantiate<GameObject>(baseObject.gameObject);
		obj.transform.parent = this.gameObject.transform;
		obj.transform.localPosition = Vector3.zero;
		obj.transform.localRotation = Quaternion.identity;
		obj.transform.localScale    = Vector3.one;
		obj.SetActive(true);

		obj.GetComponent<SpeedFxObj>().Setup(Random.Range(0, 360));			// ランダムな方向に出す 
	}

	//--------------------------------------------------------------------------------
	// デバッグ 
	//--------------------------------------------------------------------------------
	void Update ()
	{
		if(DebugSwitch.isDebugEnable == false){ return; }

		if(Input.GetKeyDown(KeyCode.Z)){
			for(int i=0; i<NUM; i++){
				Spawn();
			}
		}
	}
}
