﻿// SplashFx.cs
//
// @idex Unity5.5.0f1 / MonoDevelop5.9.6
// @auth GGJFKS17C.FCEI.No-Va
// @date 2017/01/22 
//------------------------------------------------------------------------------------------------------------------------
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.IO;

//----------------------------------------------------------------------------------------------------
// 文字しぶき演出管理 
//------------------------------------------------------------------------------------------
public class SplashFx : MonoBehaviour
{
	//--------------------------------------------------------------------------------
	// メンバ変数  
	//--------------------------------------------------------------------------------
	static SplashFx instance; 
	[SerializeField]SplashFxObj baseObject  = null; 	//@@ Instantiateの元 
	[SerializeField]GameObject  splashPivit = null;		//@@ 板の尾の部分 

	//--------------------------------------------------------------------------------
	// コンストラクタ 
	//--------------------------------------------------------------------------------
	void Awake ()
	{
		// シングルトン生成 (Fast-Priority型) 
		if(instance == null){
			instance = this;
			DontDestroyOnLoad(this.gameObject);
		}
		else{
			GameObject.Destroy(this.gameObject);
		}
	}



	//--------------------------------------------------------------------------------
	// 生成　
	//--------------------------------------------------------------------------------
	public static void Spawn ()
	{
		instance.SpawnNaked();
	}
	void SpawnNaked ()
	{
		GameObject obj = Instantiate<GameObject>(baseObject.gameObject);
		obj.transform.parent = this.gameObject.transform;
		obj.transform.localPosition = Vector3.zero;
		obj.transform.localRotation = Quaternion.identity;
		obj.transform.localScale    = Vector3.one;
		obj.transform.position      = splashPivit.transform.position;
		obj.SetActive(true);

		string rand = GetRandomStr();

		obj.GetComponent<SplashFxObj>().Setup(rand);
	}

	//--------------------------------------------------------------------------------
	// ランダム文字の取得 
	//--------------------------------------------------------------------------------
	public static string GetRandomStr ()
	{
		int rand = Random.Range(0,4);
		if(rand == 0){
			rand = '0' + Random.Range(0,10);
		}
		else if(rand == 1){
			rand = '0' + Random.Range(0, 27);
		}
		else{
			rand = '0' + Random.Range(0, 27);
		}

		return ((char)rand).ToString();
	}

	//--------------------------------------------------------------------------------
	// スプラッシュの出所を決定 
	//--------------------------------------------------------------------------------
	public static void SetPivot (GameObject obj)
	{
		instance.splashPivit = obj;
	}

	//--------------------------------------------------------------------------------
	// debug
	//--------------------------------------------------------------------------------
	void Update ()
	{
		if(DebugSwitch.isDebugEnable == false){ return; }

		if(Input.GetKey(KeyCode.V)){
			Spawn();
		}
	}
}
